commit 548848ba3b02c5f1ff46a1e791b6c15b914fc1bc
Author: Leonidas Poulopoulos <leopoul@noc.grnet.gr>
Date:   Tue Oct 30 15:32:02 2012 +0200

    Changed folder static to fodstatic to ease development and debugging

diff --git a/static/css/base.css b/static/css/base.css
index c524d78..0c57956 100644
--- a/static/css/base.css
+++ b/static/css/base.css
@@ -39,7 +39,7 @@ a:hover {
 }
 */
 #main {
-    background: url("/static/background.png") repeat-x scroll 0 0 #FFFFFF;
+    background: url("/fodstatic/background.png") repeat-x scroll 0 0 #FFFFFF;
     padding: 0;
     margin: 0;
 }
@@ -75,7 +75,7 @@ a:hover {
     -moz-box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
     -webkit-box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
     box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
-	background: url("/static/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
     border-color: #E9E9E9 #E9E9E9 #F5F5F5;
     border-style: solid;
     border-width: 1px;
@@ -94,7 +94,7 @@ a:hover {
 
 .topmenuaction{
 	padding: 4px;
-	background: url("/static/rule.png") no-repeat scroll 0 50% transparent;
+	background: url("/fodstatic/rule.png") no-repeat scroll 0 50% transparent;
 }
 
 body {
@@ -272,7 +272,7 @@ textarea#id_comments {
     -moz-box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
 	-webkit-box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
 	box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
-	background: url("/static/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
     border-color: #E9E9E9 #E9E9E9 #F5F5F5;
     border-style: solid;
     border-width: 1px;
@@ -297,7 +297,7 @@ textarea#id_comments {
     -moz-box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
 	-webkit-box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
 	box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
-	background: url("/static/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
     border-color: #E9E9E9 #E9E9E9 #F5F5F5;
     border-style: solid;
     border-width: 1px;
@@ -340,7 +340,7 @@ margin: 1px;
 	text-decoration: none;
 }
 .table_title{
-	background: url("/static/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
 }
 .inner_table{
 	border-collapse: collapse;
@@ -351,14 +351,14 @@ margin: 1px;
 	padding: 0px !important;
 }
 .table_top_header{
-	background: url("/static/css/smoothness/images/ui-bg_highlight-soft_75_cccccc_1x100.png") repeat-x scroll 50% 50% #CCCCCC;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_highlight-soft_75_cccccc_1x100.png") repeat-x scroll 50% 50% #CCCCCC;
 }
 .borderless{
 	border: 0 none !important;
 }
 .inner_category{
 	width: 35%;
-	background: url("/static/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
 	border-left: 0 none !important;
 }
 .no_brd_right{
@@ -401,7 +401,7 @@ margin: 1px;
 .conf_table th{
 	font-weight: normal;
 	background-color: #ECECEC; /* fallback color if gradients are not supported */
-	background: url("/static/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
+	background: url("/fodstatic/css/smoothness/images/ui-bg_glass_75_e6e6e6_1x400.png") repeat-x scroll 50% 50% #E6E6E6;
 	border-bottom: 1px solid #D9D9D9;
 }
 .conf_table{
@@ -417,7 +417,7 @@ margin: 1px;
 }
 .conf_table .table_topper_header{
 	font-weight: bold;
-	background: url("/static/css/smoothness/images/ui-bg_highlight-soft_75_cccccc_1x100.png") repeat-x scroll 50% 50% #CCCCCC;	
+	background: url("/fodstatic/css/smoothness/images/ui-bg_highlight-soft_75_cccccc_1x100.png") repeat-x scroll 50% 50% #CCCCCC;	
 }
 .instance_det_table{
 	border-collapse: collapse;
@@ -513,12 +513,12 @@ table.table thead .sorting_desc_disabled {
 	*cursor: hand;
 }
 
-table.table thead .sorting { background: url('/static/img/sort_both.png') no-repeat center right; }
-table.table thead .sorting_asc { background: url('/static/img/sort_asc.png') no-repeat center right; }
-table.table thead .sorting_desc { background: url('/static/img/sort_desc.png') no-repeat center right; }
+table.table thead .sorting { background: url('/fodstatic/img/sort_both.png') no-repeat center right; }
+table.table thead .sorting_asc { background: url('/fodstatic/img/sort_asc.png') no-repeat center right; }
+table.table thead .sorting_desc { background: url('/fodstatic/img/sort_desc.png') no-repeat center right; }
 
-table.table thead .sorting_asc_disabled { background: url('/static/img/sort_asc_disabled.png') no-repeat center right; }
-table.table thead .sorting_desc_disabled { background: url('/static/img/sort_desc_disabled.png') no-repeat center right; }
+table.table thead .sorting_asc_disabled { background: url('/fodstatic/img/sort_asc_disabled.png') no-repeat center right; }
+table.table thead .sorting_desc_disabled { background: url('/fodstatic/img/sort_desc_disabled.png') no-repeat center right; }
 
 table.dataTable th:active {
 	outline: none;